diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/trace-fading-loss-model.cc ns-3.40/src/spectrum/model/trace-fading-loss-model.cc
--- ns-3.39/src/spectrum/model/trace-fading-loss-model.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/trace-fading-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -18,16 +18,17 @@
  *         Marco Miozzo <mmiozzo@cttc.es>
  */
 
+#include "trace-fading-loss-model.h"
+
 #include "spectrum-signal-parameters.h"
+#include "spectrum-value.h"
 
 #include "ns3/uinteger.h"
 #include <ns3/double.h>
 #include <ns3/log.h>
 #include <ns3/mobility-model.h>
 #include <ns3/simulator.h>
-#include <ns3/spectrum-value.h>
 #include <ns3/string.h>
-#include <ns3/trace-fading-loss-model.h>
 
 #include <fstream>
 
@@ -152,9 +153,8 @@
 {
     NS_LOG_FUNCTION(this << *params->psd << a << b);
 
-    std::map<ChannelRealizationId_t, int>::iterator itOff;
     ChannelRealizationId_t mobilityPair = std::make_pair(a, b);
-    itOff = m_windowOffsetsMap.find(mobilityPair);
+    auto itOff = m_windowOffsetsMap.find(mobilityPair);
     if (itOff != m_windowOffsetsMap.end())
     {
         if (Simulator::Now().GetSeconds() >=
@@ -162,11 +162,10 @@
         {
             // update all the offsets
             NS_LOG_INFO("Fading Windows Updated");
-            std::map<ChannelRealizationId_t, int>::iterator itOff2;
-            for (itOff2 = m_windowOffsetsMap.begin(); itOff2 != m_windowOffsetsMap.end(); itOff2++)
+            for (auto itOff2 = m_windowOffsetsMap.begin(); itOff2 != m_windowOffsetsMap.end();
+                 itOff2++)
             {
-                std::map<ChannelRealizationId_t, Ptr<UniformRandomVariable>>::iterator itVar;
-                itVar = m_startVariableMap.find((*itOff2).first);
+                auto itVar = m_startVariableMap.find((*itOff2).first);
                 (*itOff2).second = (*itVar).second->GetValue();
             }
             m_lastWindowUpdate = Simulator::Now();
@@ -198,7 +197,7 @@
     }
 
     Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue>(params->psd);
-    Values::iterator vit = rxPsd->ValuesBegin();
+    auto vit = rxPsd->ValuesBegin();
 
     // Vector aSpeedVector = a->GetVelocity ();
     // Vector bSpeedVector = b->GetVelocity ();
@@ -246,8 +245,7 @@
     m_streamsAssigned = true;
     m_currentStream = stream;
     m_lastStream = stream + m_streamSetSize - 1;
-    std::map<ChannelRealizationId_t, Ptr<UniformRandomVariable>>::iterator itVar;
-    itVar = m_startVariableMap.begin();
+    auto itVar = m_startVariableMap.begin();
     // the following loop is for eventually pre-existing ChannelRealization instances
     // note that more instances are expected to be created at run time
     while (itVar != m_startVariableMap.end())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/trace-fading-loss-model.h ns-3.40/src/spectrum/model/trace-fading-loss-model.h
--- ns-3.39/src/spectrum/model/trace-fading-loss-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/trace-fading-loss-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -21,10 +21,11 @@
 #ifndef TRACE_FADING_LOSS_MODEL_H
 #define TRACE_FADING_LOSS_MODEL_H
 
+#include "spectrum-propagation-loss-model.h"
+
 #include "ns3/random-variable-stream.h"
 #include <ns3/nstime.h>
 #include <ns3/object.h>
-#include <ns3/spectrum-propagation-loss-model.h>
 
 #include <map>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/tv-spectrum-transmitter.cc ns-3.40/src/spectrum/model/tv-spectrum-transmitter.cc
--- ns-3.39/src/spectrum/model/tv-spectrum-transmitter.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/tv-spectrum-transmitter.cc	2023-09-27 13:30:37.874839800 -0700
@@ -246,7 +246,7 @@
     NS_ASSERT(m_channelBandwidth != 0);
     Ptr<SpectrumModel> model;
     TvSpectrumModelId key(m_startFrequency, m_channelBandwidth);
-    std::map<TvSpectrumModelId, Ptr<SpectrumModel>>::iterator iter = g_tvSpectrumModelMap.find(key);
+    auto iter = g_tvSpectrumModelMap.find(key);
     if (iter != g_tvSpectrumModelMap.end())
     {
         model = iter->second; // set SpectrumModel to previously created one
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/tv-spectrum-transmitter.h ns-3.40/src/spectrum/model/tv-spectrum-transmitter.h
--- ns-3.39/src/spectrum/model/tv-spectrum-transmitter.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/tv-spectrum-transmitter.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,13 +20,14 @@
 #ifndef TV_SPECTRUM_TRANSMITTER_H
 #define TV_SPECTRUM_TRANSMITTER_H
 
+#include "spectrum-channel.h"
+#include "spectrum-phy.h"
+#include "spectrum-signal-parameters.h"
+#include "spectrum-value.h"
+
 #include <ns3/antenna-model.h>
 #include <ns3/mobility-model.h>
 #include <ns3/net-device.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-signal-parameters.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h
--- ns-3.39/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -19,9 +19,10 @@
 #ifndef TWO_RAY_SPECTRUM_PROPAGATION_LOSS_H
 #define TWO_RAY_SPECTRUM_PROPAGATION_LOSS_H
 
+#include "phased-array-spectrum-propagation-loss-model.h"
+#include "spectrum-signal-parameters.h"
+
 #include "ns3/channel-condition-model.h"
-#include "ns3/phased-array-spectrum-propagation-loss-model.h"
-#include "ns3/spectrum-signal-parameters.h"
 
 #include <map>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/waveform-generator.h ns-3.40/src/spectrum/model/waveform-generator.h
--- ns-3.39/src/spectrum/model/waveform-generator.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/waveform-generator.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,14 +20,15 @@
 #ifndef WAVEFORM_GENERATOR_H
 #define WAVEFORM_GENERATOR_H
 
+#include "spectrum-channel.h"
+#include "spectrum-phy.h"
+#include "spectrum-value.h"
+
 #include <ns3/event-id.h>
 #include <ns3/mobility-model.h>
 #include <ns3/net-device.h>
 #include <ns3/nstime.h>
 #include <ns3/packet.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-value.h>
 #include <ns3/trace-source-accessor.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.cc ns-3.40/src/spectrum/model/wifi-spectrum-value-helper.cc
--- ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/wifi-spectrum-value-helper.cc	2023-09-27 13:30:37.878839700 -0700
@@ -77,8 +77,7 @@
     NS_LOG_FUNCTION(centerFrequency << channelWidth << carrierSpacing << guardBandwidth);
     Ptr<SpectrumModel> ret;
     WifiSpectrumModelId key{centerFrequency, channelWidth, carrierSpacing, guardBandwidth};
-    std::map<WifiSpectrumModelId, Ptr<SpectrumModel>>::iterator it =
-        g_wifiSpectrumModelMap.find(key);
+    auto it = g_wifiSpectrumModelMap.find(key);
     if (it != g_wifiSpectrumModelMap.end())
     {
         ret = it->second;
@@ -89,7 +88,7 @@
         double centerFrequencyHz = centerFrequency * 1e6;
         double bandwidth = (channelWidth + (2.0 * guardBandwidth)) * 1e6;
         // For OFDM, the center subcarrier is null (at center frequency)
-        uint32_t numBands = static_cast<uint32_t>((bandwidth / carrierSpacing) + 0.5);
+        auto numBands = static_cast<uint32_t>((bandwidth / carrierSpacing) + 0.5);
         NS_ASSERT(numBands > 0);
         if (numBands % 2 == 0)
         {
@@ -134,11 +133,10 @@
     uint32_t carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    Values::iterator vit = c->ValuesBegin();
-    Bands::const_iterator bit = c->ConstBandsBegin();
-    uint32_t nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    uint32_t nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto vit = c->ValuesBegin();
+    auto bit = c->ConstBandsBegin();
+    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1));
     // Evenly spread power across 22 MHz
     double txPowerPerBand = txPowerW / nAllocatedBands;
@@ -188,9 +186,8 @@
 
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    uint32_t nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    uint32_t nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     // 52 subcarriers (48 data + 4 pilot)
@@ -240,9 +237,8 @@
     uint32_t carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    uint32_t nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    uint32_t nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     std::size_t num20MhzBands = channelWidth / 20;
@@ -281,7 +277,7 @@
     }
 
     // Prepare spectrum mask specific variables
-    uint32_t innerSlopeWidth = static_cast<uint32_t>(
+    auto innerSlopeWidth = static_cast<uint32_t>(
         (2e6 / carrierSpacing) +
         0.5); // size in number of subcarriers of the 0dBr<->20dBr slope (2MHz for HT/VHT)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
@@ -315,9 +311,8 @@
     uint32_t carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    uint32_t nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    uint32_t nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     std::size_t num20MhzBands = channelWidth / 20;
@@ -347,7 +342,7 @@
     }
 
     // Prepare spectrum mask specific variables
-    uint32_t innerSlopeWidth = static_cast<uint32_t>(
+    auto innerSlopeWidth = static_cast<uint32_t>(
         (2e6 / carrierSpacing) +
         0.5); // size in number of subcarriers of the inner band (2MHz for HT/VHT)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
@@ -383,9 +378,8 @@
     uint32_t carrierSpacing = 78125;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    uint32_t nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    uint32_t nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     double txPowerPerBandW = 0.0;
@@ -398,7 +392,7 @@
     uint32_t start4;
     uint32_t stop4;
     // Prepare spectrum mask specific variables
-    uint32_t innerSlopeWidth = static_cast<uint32_t>(
+    auto innerSlopeWidth = static_cast<uint32_t>(
         (1e6 / carrierSpacing) + 0.5); // size in number of subcarriers of the inner band
     std::vector<WifiSpectrumBandIndices>
         subBands; // list of data/pilot-containing subBands (sent at 0dBr)
@@ -468,7 +462,7 @@
     }
 
     // Create punctured bands
-    uint32_t puncturedSlopeWidth =
+    auto puncturedSlopeWidth =
         static_cast<uint32_t>((500e3 / carrierSpacing) +
                               0.5); // size in number of subcarriers of the punctured slope band
     std::vector<WifiSpectrumBandIndices> puncturedBands;
@@ -516,8 +510,8 @@
         GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
 
     // Build spectrum mask
-    Values::iterator vit = c->ValuesBegin();
-    Bands::const_iterator bit = c->ConstBandsBegin();
+    auto vit = c->ValuesBegin();
+    auto bit = c->ConstBandsBegin();
     double txPowerPerBandW = (txPowerW / (ru.second - ru.first + 1)); // FIXME: null subcarriers
     uint32_t numBands = c->GetSpectrumModel()->GetNumBands();
     for (size_t i = 0; i < numBands; i++, vit++, bit++)
@@ -655,8 +649,8 @@
     double puncturedSlope = (-1 * minInnerBandDbr) / puncturedSlopeWidth;
 
     // Build spectrum mask
-    Values::iterator vit = c->ValuesBegin();
-    Bands::const_iterator bit = c->ConstBandsBegin();
+    auto vit = c->ValuesBegin();
+    auto bit = c->ConstBandsBegin();
     double txPowerW = 0.0;
     double previousTxPowerW = 0.0;
     for (size_t i = 0; i < numBands; i++, vit++, bit++)
@@ -780,7 +774,7 @@
     double normalizationRatio = currentTxPowerW / txPowerW;
     NS_LOG_LOGIC("Current power: " << currentTxPowerW << "W vs expected power: " << txPowerW << "W"
                                    << " -> ratio (C/E) = " << normalizationRatio);
-    Values::iterator vit = c->ValuesBegin();
+    auto vit = c->ValuesBegin();
     for (size_t i = 0; i < c->GetSpectrumModel()->GetNumBands(); i++, vit++)
     {
         *vit = (*vit) / normalizationRatio;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.h ns-3.40/src/spectrum/model/wifi-spectrum-value-helper.h
--- ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/wifi-spectrum-value-helper.h	2023-09-27 13:30:37.878839700 -0700
@@ -22,7 +22,7 @@
 #ifndef WIFI_SPECTRUM_VALUE_HELPER_H
 #define WIFI_SPECTRUM_VALUE_HELPER_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/test/spectrum-interference-test.cc ns-3.40/src/spectrum/test/spectrum-interference-test.cc
--- ns-3.39/src/spectrum/test/spectrum-interference-test.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/test/spectrum-interference-test.cc	2023-09-27 13:30:37.878839700 -0700
@@ -44,7 +44,7 @@
      * Constructor
      * \param s Spectrum value
      * \param txBytes number of bytes to transmit
-     * \param rxCorrect extected Rx bytes
+     * \param rxCorrect expected Rx bytes
      * \param name test name
      */
     SpectrumInterferenceTestCase(Ptr<SpectrumValue> s,
@@ -62,7 +62,7 @@
   private:
     Ptr<SpectrumValue> m_s;                     //!< Spectrum value
     uint32_t m_txBytes;                         //!< number of bytes to transmit
-    uint32_t m_rxCorrectKnownOutcome;           //!< expected Rx bytes
+    bool m_rxCorrectKnownOutcome;               //!< expected Rx bytes
     Ptr<const SpectrumModel> m_mySpectrumModel; //!< Spectrum model pointer
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/test/spectrum-test.h ns-3.40/src/spectrum/test/spectrum-test.h
--- ns-3.39/src/spectrum/test/spectrum-test.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/test/spectrum-test.h	2023-09-27 13:30:37.878839700 -0700
@@ -48,8 +48,8 @@
 #define NS_TEST_ASSERT_MSG_SPECTRUM_MODEL_EQ_TOL(actual, expected, tol, msg)                       \
     do                                                                                             \
     {                                                                                              \
-        Bands::const_iterator i = (actual).Begin();                                                \
-        Bands::const_iterator j = (expected).Begin();                                              \
+        auto i = (actual).Begin();                                                                 \
+        auto j = (expected).Begin();                                                               \
         uint32_t k = 0;                                                                            \
         while (i != (actual).End() && j != (expected).End())                                       \
         {                                                                                          \
@@ -113,8 +113,8 @@
 #define NS_TEST_ASSERT_MSG_SPECTRUM_VALUE_EQ_TOL(actual, expected, tol, msg)                       \
     do                                                                                             \
     {                                                                                              \
-        Values::const_iterator i = (actual).ConstValuesBegin();                                    \
-        Values::const_iterator j = (expected).ConstValuesBegin();                                  \
+        auto i = (actual).ConstValuesBegin();                                                      \
+        auto j = (expected).ConstValuesBegin();                                                    \
         uint32_t k = 0;                                                                            \
         while (i != (actual).ConstValuesEnd() && j != (expected).ConstValuesEnd())                 \
         {                                                                                          \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/test/tv-spectrum-transmitter-test.cc ns-3.40/src/spectrum/test/tv-spectrum-transmitter-test.cc
--- ns-3.39/src/spectrum/test/tv-spectrum-transmitter-test.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/test/tv-spectrum-transmitter-test.cc	2023-09-27 13:30:37.878839700 -0700
@@ -124,7 +124,7 @@
 
     /* Test max PSD value */
     Ptr<SpectrumValue> psd = phy->GetTxPsd();
-    Values::const_iterator psdIter = psd->ConstValuesBegin();
+    auto psdIter = psd->ConstValuesBegin();
     double maxValue = 0;
     while (psdIter != psd->ConstValuesEnd())
     {
@@ -154,8 +154,8 @@
     }
 
     /* Test frequency range */
-    Bands::const_iterator bandStart = psd->ConstBandsBegin();
-    Bands::const_iterator bandEnd = psd->ConstBandsEnd();
+    auto bandStart = psd->ConstBandsBegin();
+    auto bandEnd = psd->ConstBandsEnd();
     epsilon = TOLERANCE * std::max(1.0, std::max((*bandStart).fc, m_startFrequency));
     NS_TEST_ASSERT_MSG_EQ_TOL((*bandStart).fc,
                               m_startFrequency,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/test/two-ray-splm-test-suite.cc ns-3.40/src/spectrum/test/two-ray-splm-test-suite.cc
--- ns-3.39/src/spectrum/test/two-ray-splm-test-suite.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/spectrum/test/two-ray-splm-test-suite.cc	2023-09-27 13:30:37.878839700 -0700
@@ -153,8 +153,10 @@
     // Generate a set of values for the FTR model parameters
     for (uint8_t j = 0; j < NUM_VALUES; j++)
     {
-        sigma[j] = std::pow(2, j);
-        k[j] = std::pow(2, j);
+        double power = std::pow(2, j);
+
+        sigma[j] = power;
+        k[j] = power;
         delta[j] = double(j) / NUM_VALUES; // Delta must be in [0, 1]
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/utils/two-ray-to-three-gpp-ch-calibration.py ns-3.40/src/spectrum/utils/two-ray-to-three-gpp-ch-calibration.py
--- ns-3.39/src/spectrum/utils/two-ray-to-three-gpp-ch-calibration.py	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/spectrum/utils/two-ray-to-three-gpp-ch-calibration.py	2023-09-27 13:30:37.878839700 -0700
@@ -220,7 +220,7 @@
 def compute_anderson_darling_measure(ref_ecdf: list, target_ecdf: list) -> float:
     '''!  Computes the Anderson-Darling measure for the specified reference and targets distributions.
           In particular, the Anderson-Darling measure is defined as:
-          A^2 = -N -S, where S = \sum_{i=1}^N \frac{2i - 1}{N} \left[ ln F(Y_i) + ln F(Y_{N + 1 - i}) \right].
+          \f$A^2 = -N -S\f$, where \f$S = \sum_{i=1}^N \frac{2i - 1}{N} \left[ ln F(Y_i) + ln F(Y_{N + 1 - i}) \right]\f$.
 
           See https://www.itl.nist.gov/div898/handbook/eda/section3/eda35e.htm for further details.
 
@@ -248,7 +248,7 @@
 def compute_ecdf_value(ecdf: list, data_points: float) -> np.ndarray:
     '''!  Given an ECDF and data points belonging to its domain, returns their associated EDCF value.
         @param ecdf: The ECDF, represented as a sorted list of samples.
-        @param data_point: A list of data points belonging to the same domain as the samples.
+        @param data_points: A list of data points belonging to the same domain as the samples.
         @returns The ECDF value of the domain points of the specified ECDF
     '''
 
@@ -438,9 +438,8 @@
     out_str = out_str[0:-2]
     out_str += '}\n'
 
-    f = open(out_fname, "w")
-    f.write(out_str)
-    f.close()
+    with open(out_fname, "w", encoding="utf-8") as f:
+        f.write(out_str)
 
 
 if __name__ == '__main__':
@@ -499,12 +498,10 @@
             res = joblib.Parallel(n_jobs=10)(
                 joblib.delayed(fit_ftr_to_reference)(df, params_comb, num_search_grid_params, num_refinements) for params_comb in product(scenarios, is_los, frequencies))
 
-        f = open(fit_out_fname, "w")
-        f.write("scen\tcond\tfc\tsigma\tk\tdelta\tm\n")
-        for line in res:
-            f.write(line)
-
-        f.close()
+        with open(fit_out_fname, "w", encoding="utf-8") as f:
+            f.write("scen\tcond\tfc\tsigma\tk\tdelta\tm\n")
+            for line in res:
+                f.write(line)
 
     if output_ns3_table:
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/helper/file-helper.cc ns-3.40/src/stats/helper/file-helper.cc
--- ns-3.39/src/stats/helper/file-helper.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/helper/file-helper.cc	2023-09-27 13:30:37.878839700 -0700
@@ -288,8 +288,7 @@
     NS_LOG_FUNCTION(this << probeName);
 
     // Look for the probe.
-    std::map<std::string, std::pair<Ptr<Probe>, std::string>>::const_iterator mapIterator =
-        m_probeMap.find(probeName);
+    auto mapIterator = m_probeMap.find(probeName);
 
     // Return the probe if it has been added.
     if (mapIterator != m_probeMap.end())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/helper/gnuplot-helper.cc ns-3.40/src/stats/helper/gnuplot-helper.cc
--- ns-3.39/src/stats/helper/gnuplot-helper.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/helper/gnuplot-helper.cc	2023-09-27 13:30:37.878839700 -0700
@@ -257,8 +257,7 @@
 GnuplotHelper::GetProbe(std::string probeName) const
 {
     // Look for the probe.
-    std::map<std::string, std::pair<Ptr<Probe>, std::string>>::const_iterator mapIterator =
-        m_probeMap.find(probeName);
+    auto mapIterator = m_probeMap.find(probeName);
 
     // Return the probe if it has been added.
     if (mapIterator != m_probeMap.end())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/average.h ns-3.40/src/stats/model/average.h
--- ns-3.39/src/stats/model/average.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/average.h	2023-09-27 13:30:37.878839700 -0700
@@ -20,7 +20,8 @@
 
 #ifndef AVERAGE_H
 #define AVERAGE_H
-#include "ns3/basic-data-calculators.h"
+
+#include "basic-data-calculators.h"
 
 #include <cmath>
 #include <limits>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/boolean-probe.cc ns-3.40/src/stats/model/boolean-probe.cc
--- ns-3.39/src/stats/model/boolean-probe.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/boolean-probe.cc	2023-09-27 13:30:37.878839700 -0700
@@ -20,7 +20,7 @@
  * Modified by: Mitch Watrous (watrous@u.washington.edu)
  */
 
-#include "ns3/boolean-probe.h"
+#include "boolean-probe.h"
 
 #include "ns3/config.h"
 #include "ns3/log.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/boolean-probe.h ns-3.40/src/stats/model/boolean-probe.h
--- ns-3.39/src/stats/model/boolean-probe.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/boolean-probe.h	2023-09-27 13:30:37.878839700 -0700
@@ -23,10 +23,11 @@
 #ifndef BOOL_PROBE_H
 #define BOOL_PROBE_H
 
+#include "probe.h"
+
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
 #include "ns3/object.h"
-#include "ns3/probe.h"
 #include "ns3/simulator.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/data-output-interface.h ns-3.40/src/stats/model/data-output-interface.h
--- ns-3.39/src/stats/model/data-output-interface.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/data-output-interface.h	2023-09-27 13:30:37.878839700 -0700
@@ -20,7 +20,8 @@
 #ifndef DATA_OUTPUT_INTERFACE_H
 #define DATA_OUTPUT_INTERFACE_H
 
-#include "ns3/data-calculator.h"
+#include "data-calculator.h"
+
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/double-probe.cc ns-3.40/src/stats/model/double-probe.cc
--- ns-3.39/src/stats/model/double-probe.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/double-probe.cc	2023-09-27 13:30:37.878839700 -0700
@@ -20,7 +20,7 @@
  * Modified by: Mitch Watrous (watrous@u.washington.edu)
  */
 
-#include "ns3/double-probe.h"
+#include "double-probe.h"
 
 #include "ns3/config.h"
 #include "ns3/log.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/double-probe.h ns-3.40/src/stats/model/double-probe.h
--- ns-3.39/src/stats/model/double-probe.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/double-probe.h	2023-09-27 13:30:37.878839700 -0700
@@ -23,10 +23,11 @@
 #ifndef DOUBLE_PROBE_H
 #define DOUBLE_PROBE_H
 
+#include "probe.h"
+
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
 #include "ns3/object.h"
-#include "ns3/probe.h"
 #include "ns3/simulator.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/file-aggregator.h ns-3.40/src/stats/model/file-aggregator.h
--- ns-3.39/src/stats/model/file-aggregator.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/file-aggregator.h	2023-09-27 13:30:37.878839700 -0700
@@ -23,7 +23,7 @@
 #ifndef FILE_AGGREGATOR_H
 #define FILE_AGGREGATOR_H
 
-#include "ns3/data-collection-object.h"
+#include "data-collection-object.h"
 
 #include <fstream>
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/gnuplot-aggregator.h ns-3.40/src/stats/model/gnuplot-aggregator.h
--- ns-3.39/src/stats/model/gnuplot-aggregator.h	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/gnuplot-aggregator.h	2023-09-27 13:30:37.878839700 -0700
@@ -23,8 +23,8 @@
 #ifndef GNUPLOT_AGGREGATOR_H
 #define GNUPLOT_AGGREGATOR_H
 
-#include "ns3/data-collection-object.h"
-#include "ns3/gnuplot.h"
+#include "data-collection-object.h"
+#include "gnuplot.h"
 
 #include <map>
 #include <string>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/gnuplot.cc ns-3.40/src/stats/model/gnuplot.cc
--- ns-3.39/src/stats/model/gnuplot.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/gnuplot.cc	2023-09-27 13:30:37.878839700 -0700
@@ -293,7 +293,7 @@
 void
 Gnuplot2dDataset::Data2d::PrintDataFile(std::ostream& os, bool generateOneOutputFile) const
 {
-    for (PointSet::const_iterator i = m_pointset.begin(); i != m_pointset.end(); ++i)
+    for (auto i = m_pointset.begin(); i != m_pointset.end(); ++i)
     {
         if (i->empty)
         {
@@ -578,7 +578,7 @@
 void
 Gnuplot3dDataset::Data3d::PrintDataFile(std::ostream& os, bool generateOneOutputFile) const
 {
-    for (PointSet::const_iterator i = m_pointset.begin(); i != m_pointset.end(); ++i)
+    for (auto i = m_pointset.begin(); i != m_pointset.end(); ++i)
     {
         if (i->empty)
         {
@@ -852,7 +852,7 @@
 
     std::string command = m_datasets.begin()->m_data->GetCommand();
 
-    for (Datasets::const_iterator i = m_datasets.begin() + 1; i != m_datasets.end(); ++i)
+    for (auto i = m_datasets.begin() + 1; i != m_datasets.end(); ++i)
     {
         NS_ASSERT_MSG(command == i->m_data->GetCommand(),
                       "Cannot mix 'plot' and 'splot' GnuplotDatasets.");
@@ -863,7 +863,7 @@
     // Print all dataset expressions
 
     bool isDataEmpty;
-    for (Datasets::const_iterator i = m_datasets.begin(); i != m_datasets.end();)
+    for (auto i = m_datasets.begin(); i != m_datasets.end();)
     {
         // Only print the dataset if it's not empty.
         isDataEmpty = i->m_data->IsEmpty();
@@ -889,7 +889,7 @@
 
     // followed by the inline datafile.
 
-    for (Datasets::const_iterator i = m_datasets.begin(); i != m_datasets.end(); i++)
+    for (auto i = m_datasets.begin(); i != m_datasets.end(); i++)
     {
         i->m_data->PrintDataFile(osData, m_generateOneOutputFile);
     }
@@ -950,7 +950,7 @@
         os << "set output \"" << m_outputFilename << "\"" << std::endl;
     }
 
-    for (Plots::iterator i = m_plots.begin(); i != m_plots.end(); ++i)
+    for (auto i = m_plots.begin(); i != m_plots.end(); ++i)
     {
         i->GenerateOutput(os);
     }
@@ -974,7 +974,7 @@
         osControl << "set output \"" << m_outputFilename << "\"" << std::endl;
     }
 
-    for (Plots::iterator i = m_plots.begin(); i != m_plots.end(); ++i)
+    for (auto i = m_plots.begin(); i != m_plots.end(); ++i)
     {
         i->GenerateOutput(osControl, osData, dataFileName);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/stats/model/histogram.cc ns-3.40/src/stats/model/histogram.cc
--- ns-3.39/src/stats/model/histogram.cc	2023-07-05 14:23:48.085428200 -0700
+++ ns-3.40/src/stats/model/histogram.cc	2023-09-27 13:30:37.878839700 -0700
@@ -80,7 +80,7 @@
 void
 Histogram::AddValue(double value)
 {
-    uint32_t index = (uint32_t)std::floor(value / m_binWidth);
+    auto index = (uint32_t)std::floor(value / m_binWidth);
 
     // check if we need to resize the vector
     NS_LOG_DEBUG("AddValue: index=" << index << ", m_histogram.size()=" << m_histogram.size());
